#property   copyright "Copyright ?2010, Antony, Fiona And Ken"
#property   link      "http://www.papazhou.com"
#define        NoSignal   -1
extern int     EMAPeriod = 5;
extern int     EMAPrice  = PRICE_CLOSE;
extern int     SMAPeriod = 20;
extern int     SMAPrice  = PRICE_CLOSE;
extern double  Lots      = 1;
extern int     TP        = 10;
extern int     SL        = 20;
extern int     Magic     = 123456;

int      Signal      = NoSignal;
int      CloseSignal = NoSignal;
int      CurrentBar  = -1;

double   ema1        = 0;
double   sma1        = 0;
double   ema2        = 0;
double   sma2        = 0;

double   lots;

int init()
{
   lots = Lots;
   return(0);
}
int deinit()
{
   return(0);
}
int start()
{
   if(Period() != PERIOD_M5)
   {
      Alert("This EA only works on M5 Period, Please adjust the current period!");
   }
   if(CurrentBar < Bars)
   {
      Signal = GetMASignal();
      if(Signal != NoSignal)
      {
         lots = GetLots();
         if(Signal == OP_SELL)
         {
            OpenTrade(OP_SELL, lots);
            CloseSignal = OP_BUY;
         }
         if(Signal == OP_BUY)
         {
            OpenTrade(OP_BUY, lots);
            CloseSignal = OP_SELL;
         }
      }
      CurrentBar = Bars;
   }
   if(CloseSignal != NoSignal)
   {
      CloseTrades(CloseSignal);
      if(!IsTradeExist(CloseSignal))
      {
         CloseSignal = NoSignal;
      }
   }
   return(0);
}

//Not yet implement for auto calculate the lots by the account size
double GetLots()
{
   return(Lots);
}

//Checking whether the Buy or Sell trade exist
bool IsTradeExist(int cmd)
{
   int count = OrdersTotal();
   for(int i=0; i<count; i++)
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if(OrderMagicNumber() == Magic && OrderSymbol() == Symbol())
            if(OrderType() == cmd)
               return (true);
   return(false);
}

//Close Order function
void CloseTrades(int cmd)
{
   int count = OrdersTotal();
   for(int i=0; i<count; i++)
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if(OrderMagicNumber() == Magic && OrderSymbol() == Symbol())
            if(OrderType() == cmd)
            {
               if(OrderType() == OP_BUY)
                  OrderClose(OrderTicket(), OrderLots(), Bid, 0, Green);
               if(OrderType() == OP_SELL)
                  OrderClose(OrderTicket(), OrderLots(), Ask, 0, Pink);
            }
}

//Since some broker donot support SL & TP while sending the Order
//So use this extra function to modify the SL & TP
void ModifyTrade(int cmd, int ticket)
{
   double tp, sl;
   color  clr;
   if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
   {
      if(cmd == OP_BUY)
      {
         tp = NormalizeDouble(OrderOpenPrice() + TP*MarketInfo(Symbol(), MODE_POINT), MarketInfo(Symbol(), MODE_DIGITS));
         sl = NormalizeDouble(OrderOpenPrice() - SL*MarketInfo(Symbol(), MODE_POINT), MarketInfo(Symbol(), MODE_DIGITS));
         clr = Blue;     
      }
      if(cmd == OP_SELL)
      {
         tp = NormalizeDouble(OrderOpenPrice() + TP*MarketInfo(Symbol(), MODE_POINT), MarketInfo(Symbol(), MODE_DIGITS));
         sl = NormalizeDouble(OrderOpenPrice() - SL*MarketInfo(Symbol(), MODE_POINT), MarketInfo(Symbol(), MODE_DIGITS));
         clr = Red;
      }
      Print(sl);
      OrderModify(OrderTicket(), OrderOpenPrice(), sl, tp, 0, clr);
   }
}

//Function for opening orders
void OpenTrade(int cmd, double lots)
{
   int ticket = -1;
   if(cmd == OP_BUY)
      ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 0, 0, 0, NULL, Magic, 0, Blue);
   if(cmd == OP_SELL)
      ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 0, 0, 0, NULL, Magic, 0, Red);
   if(ticket > -1)
      ModifyTrade(cmd, ticket);
}

//Checking 2 MA cross
int GetMASignal()
{
   ema1 = iMA(Symbol(), Period(), EMAPeriod, 0, MODE_EMA, EMAPrice,  1);
   sma1 = iMA(Symbol(), Period(), SMAPeriod, 0, MODE_SMMA, EMAPrice,  1);
   
   ema2 = iMA(Symbol(), Period(), EMAPeriod, 0, MODE_EMA, EMAPrice,  2);
   sma2 = iMA(Symbol(), Period(), SMAPeriod, 0, MODE_SMMA, EMAPrice,  2);
   
   if(ema1 > sma1 && ema2 < sma2)
      return(OP_BUY);
   if(ema1 < sma1 && ema2 > sma2)
      return(OP_SELL);
      
   return(NoSignal);   
}